#ifndef _FF_POLY_H
#define _FF_POLY_H

#include "patch3.h"
#include "vector4.h"

// Maximum number of output vertices
static const int MaxVert = 10;

class FormPoly          // Form factor polygon
{
  private:
	 Point3 posn[MaxVert];       // Output vertex array
	 int num_vert;               // Number of vertices
	 WORD ident;                 // Polygon identifier

	 void AddVertex( Vector4 &v )
	 { v.Perspective(&(posn[num_vert++])); }

	 void Reset( WORD id )
	 {
		num_vert = 0;
		ident = id;
	 }

	 friend class FormClipEdge;
	 friend class FormClip;

  public:
	 FormPoly()
	 {
		num_vert = 0;
		ident = 0;
	 }

	 int GetNumVert() { return num_vert; }
	 Point3 &GetVertex( int i )
	 { return posn[i]; }
	 WORD GetPolyId() { return ident; }
};

#endif

