
#ifndef _PROG_RAD_H
#define _PROG_RAD_H

#include "environ.h"
#include "../source/rad_eqn.c"

// Progressive refinement radiosity equation solver
class ProgRad : public RadEqnSolve
{
  protected:
    float *ff_array;        // Form factor array pointer
    BOOL over_flag;         // Overshoot flag
    BOOL status;            // Object status
    FormFactor ffd;         // Form factor determination
    Spectra overshoot;      // Overshooting parameters

    void AddAmbient();
    void CalcOverShoot();

  public:
    ProgRad() : RadEqnSolve() { over_flag = TRUE; }

    ~ProgRad() { Close(); }

    BOOL Calculate();
    BOOL OverShootFlag() { return over_flag; }
    BOOL GetStatus() { return ffd.GetStatus(); }
    BOOL Open( Environ * );
    void Close();
    void DisableOverShoot() { over_flag = FALSE; }
    void EnableOverShoot() { over_flag = TRUE; }
    void Interpolate();
    void SetUpdate();
};

#endif

